#if !defined(AFX_DEBUGGER_H__6D871A81_75EC_11D5_BCEA_00A0CCD69DE3__INCLUDED_)
#define AFX_DEBUGGER_H__6D871A81_75EC_11D5_BCEA_00A0CCD69DE3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Debugger.h : header file
//
#include "dead6502\dead6502.h"
/////////////////////////////////////////////////////////////////////////////
// CDebugger dialog

class CDebugger : public CDialog
{
private:
	CBitmap up,down;
	dead6502data *cpu;
	dead6502data *maincpu,*soundcpu;
	romset_t *romset;
	u16 pos,pc;
	u32 cpu1cycles,cpu2cycles;
	u32 cpu1screen,cpu1frame,cpu2screen,cpu2frame;
	u8 currentcpu;
	void changecpu();
public:
	void setcontexts(dead6502data *cpu1,dead6502data *cpu2,romset_t *roms);
	void refresh();
// Construction
	CDebugger(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDebugger)
	enum { IDD = IDD_DEBUGGER };
	CListBox	m_disasm;
	CButton	m_up;
	CButton	m_down;
	CTabCtrl	m_tabs;
	CString	m_stepcycles;
	CString	m_jumpaddr;
	CString	m_info;
	CString	m_breakaddr;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDebugger)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDebugger)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCputabs(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRefresh();
	afx_msg void OnUp();
	afx_msg void OnDown();
	afx_msg void OnStep();
	afx_msg void OnReset();
	afx_msg void OnClose();
	virtual void OnOK();
	afx_msg void OnBreak();
	afx_msg void OnJump();
	afx_msg void OnIrq();
	afx_msg void OnNmi();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DEBUGGER_H__6D871A81_75EC_11D5_BCEA_00A0CCD69DE3__INCLUDED_)
