// Link.cpp : implementation file
//

#include "stdafx.h"
#include "breem.h"
#include "Link.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLink

CLink::CLink()
{
linkcolor = 0; //black
mouseover = 0;
}

CLink::~CLink()
{
font.DeleteObject();
}


BEGIN_MESSAGE_MAP(CLink, CStatic)
	//{{AFX_MSG_MAP(CLink)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_MOUSEMOVE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLink message handlers

HBRUSH CLink::CtlColor(CDC* pDC, UINT /*nCtlColor*/) 
{
pDC->SetTextColor(linkcolor);
pDC->SetBkMode(TRANSPARENT);
return((HBRUSH)GetStockObject(NULL_BRUSH));
}

void CLink::OnMouseMove(UINT nFlags, CPoint point) 
{
LOGFONT lf;
	// TODO: Add your message handler code here and/or call default
	
	CStatic::OnMouseMove(nFlags, point);
if(mouseover)
	{
	CRect rect;

	GetClientRect(rect);
	if(!rect.PtInRect(point))// == 0)
		{
		mouseover = 0;
		ReleaseCapture();
		RedrawWindow();
		}
	}
else
	{
	mouseover = 1;
	RedrawWindow();
	SetCapture();
	}
GetFont()->GetLogFont(&lf);
if(lf.lfUnderline != mouseover)
	{
	lf.lfUnderline = (u8)mouseover;
	font.DeleteObject();
	font.CreateFontIndirect(&lf);
	SetFont(&font);
	Invalidate();
	parent->Invalidate();
	}
}

int CLink::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatic::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
    LOGFONT lf;
    GetFont()->GetLogFont(&lf);
    lf.lfUnderline = (char)0;
    font.CreateFontIndirect(&lf);
    SetFont(&font);

	return 0;
}
