// RomViewer.cpp : implementation file
//

#include "stdafx.h"
#include "breem.h"
#include "RomViewer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRomViewer dialog


CRomViewer::CRomViewer(CWnd* pParent /*=NULL*/)
	: CDialog(CRomViewer::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRomViewer)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRomViewer::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRomViewer)
	DDX_Control(pDX, IDC_ROMTREE, m_romtree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRomViewer, CDialog)
	//{{AFX_MSG_MAP(CRomViewer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRomViewer message handlers

void CRomViewer::OnOK() 
{
	// TODO: Add extra validation here

	CDialog::OnOK();
}

void CRomViewer::setroms(romset_t **romsets)
{
m_romsets = romsets;
}

BOOL CRomViewer::OnInitDialog() 
{
romset_t *r;
int c;
HTREEITEM branch;
rom_t *rom;

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
m_imagelist.Create(IDB_ROMICONS,16,1,RGB(255,0,0));
m_romtree.SetImageList(&m_imagelist,TVSIL_NORMAL);
c = 0;
for(;;)
	{
	r = m_romsets[c++];
	if(r == 0)
		break;
	branch = m_romtree.InsertItem(r->name,0,0);
	rom = r->roms;
	while(rom->filename != 0)
		{
		m_romtree.InsertItem(rom->filename,1,1,branch);
		rom++;
		}
	if(r->parent)
		{
		HTREEITEM newbranch;
		rom_t *oldrom;
		int skip;

		newbranch = m_romtree.InsertItem(r->parent->name,0,0,branch);
		rom = r->parent->roms;
		while(rom->filename != 0)
			{
			skip = 0;
			oldrom = r->roms;
			while(oldrom->filename != 0)
				{
				if(oldrom->loadaddr == rom->loadaddr) //dont list this cloned rom
					{
					skip = 1;
					break;
					}
				oldrom++;
				}
			if(skip == 0)
				m_romtree.InsertItem(rom->filename,1,1,newbranch);
			rom++;
			}
		}
//	m_romtree.Expand(branch,TVE_EXPAND);
	}
m_romtree.SortChildren(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
