// Settings.cpp : implementation file
//

#include "stdafx.h"
#include "breem.h"
#include "Settings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettings dialog


CSettings::CSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettings)
	m_limitfps = FALSE;
	//}}AFX_DATA_INIT
}


void CSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettings)
	DDX_Control(pDX, IDC_BLITTER, m_blitter);
	DDX_Check(pDX, IDC_LIMITFPS, m_limitfps);
	//}}AFX_DATA_MAP
}

void CSettings::changeblitter()
{
void *pal;
blitter *newblitter = theApp.m_blitter;

newblitter->getpalette(&pal);
newblitter->kill();
delete newblitter;newblitter = 0;
settings.blitter = (u8)m_blitter.GetCurSel();
switch(settings.blitter)
	{
	default:settings.blitter = 0;
	case 0:newblitter = new gdiblitter;break;
	case 1:newblitter = new dxblitter;break;
	}
if(newblitter->init(256,256,256,theApp.m_pMainWnd->GetSafeHwnd()) == 0)
	::MessageBox(0,"error initing blitter","error",MB_OK|MB_ICONERROR);
else
	newblitter->setpalette(pal);
theApp.m_blitter = newblitter;
}

BEGIN_MESSAGE_MAP(CSettings, CDialog)
	//{{AFX_MSG_MAP(CSettings)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettings message handlers

BOOL CSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
m_limitfps = settings.framelimit;
m_blitter.SetCurSel(settings.blitter);
UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettings::OnOK() 
{
	// TODO: Add extra validation here
UpdateData(TRUE);
if(settings.blitter != (u8)m_blitter.GetCurSel())
	changeblitter();
settings.framelimit = (u8)m_limitfps;
	CDialog::OnOK();
}
